diff --git a/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
index 32f2dda26..13784cbdd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
@@ -11,12 +11,12 @@ import org.lwjgl.opengl.GL11;
 
 public class CacaoLeavesBlockModel<T extends Block> extends LeavesBlockModel<T> {
     protected IconCoordinate[] growthStages = new IconCoordinate[]{
-            TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage0"),
-            TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage1"),
-            TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage2"),
-            TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage3")};
+            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage0"),
+            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage1"),
+            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage2"),
+            TextureRegistry.getTexture("minecraft:block/leaves/cacao_bean_stage3")};
     public CacaoLeavesBlockModel(Block block) {
-        super(block, "minecraft:block/leaves_cacao");
+        super(block, "minecraft:block/leaves/cacao");
         assert growthStages.length == CacaoLeavesBlock.MAX_GROWTH_STATE : "There must be a texture associated with every cacao bean stage!";
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
index 099ac455c..a947da4fa 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
@@ -6,7 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
 public class CakeBlockModel<T extends Block> extends StandardBlockModel<T> {
-    protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake_inner");
+    protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake/inner");
     public CakeBlockModel(Block block) {
         super(block);
         float f = 0.0625F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
index 2844dfb7a..29727a4fe 100644
--- a/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
@@ -18,13 +18,13 @@ public class ChestBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate chestTop;
     public ChestBlockModel(Block block, String rootKey) {
         super(block);
-        chestFrontSingle = TextureRegistry.getTexture(rootKey + "_front");
-        chestFrontLeft = TextureRegistry.getTexture(rootKey + "_left_front");
-        chestFrontRight = TextureRegistry.getTexture(rootKey + "_right_front");
-        chestBackLeft = TextureRegistry.getTexture(rootKey + "_left_back");
-        chestBackRight = TextureRegistry.getTexture(rootKey + "_right_back");
-        chestSide = TextureRegistry.getTexture(rootKey + "_side");
-        chestTop = TextureRegistry.getTexture(rootKey + "_top");
+        chestFrontSingle = TextureRegistry.getTexture(rootKey + "front");
+        chestFrontLeft = TextureRegistry.getTexture(rootKey + "left_front");
+        chestFrontRight = TextureRegistry.getTexture(rootKey + "right_front");
+        chestBackLeft = TextureRegistry.getTexture(rootKey + "left_back");
+        chestBackRight = TextureRegistry.getTexture(rootKey + "right_back");
+        chestSide = TextureRegistry.getTexture(rootKey + "side");
+        chestTop = TextureRegistry.getTexture(rootKey + "top");
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
index d1cc13db0..967fb26f0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
@@ -9,19 +9,19 @@ import net.minecraft.core.util.helper.Side;
 
 public class CropsPumpkinBlockModel<T extends Block> extends StandardBlockModel<T> {
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_TOP = {
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage1_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage2_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage3_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage4_top")
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_top"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_top"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_top"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_top")
     };
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_SIDE = {
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage1_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage2_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage3_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage4_side")
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_side"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_side"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_side"),
+            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_side")
     };
 
-    public static final IconCoordinate LEAF_TEXTURE = TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage0");
+    public static final IconCoordinate LEAF_TEXTURE = TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage0");
 
     public CropsPumpkinBlockModel(Block block) {
         super(block);
diff --git a/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
index e41c614f2..d22ef58cc 100644
--- a/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
@@ -11,14 +11,14 @@ import net.minecraft.core.util.helper.Side;
 
 public class CropsWheatBlockModel<T extends Block> extends StandardBlockModel<T> {
     public final IconCoordinate[] growthStageTextures = {
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage0"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage1"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage2"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage3"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage4"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage5"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage6"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat_stage7")
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage0"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage1"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage2"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage3"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage4"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage5"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage6"),
+            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage7")
     };
 
     public CropsWheatBlockModel(Block block) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
index a2e4c9ac0..bf777338d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
@@ -3,15 +3,17 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.FarmlandBlock;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
 
 public class FarmlandBlockModel<T extends Block> extends StandardBlockModel<T> {
-    protected IconCoordinate topWet = TextureRegistry.getTexture("minecraft:block/farmland_wet_top");
-    protected IconCoordinate topWetFertilized = TextureRegistry.getTexture("minecraft:block/farmland_wet_fertilized_top");
-    protected IconCoordinate topDry = TextureRegistry.getTexture("minecraft:block/farmland_dry_top");
-    protected IconCoordinate topDryFertilized = TextureRegistry.getTexture("minecraft:block/farmland_dry_fertilized_top");
-    protected IconCoordinate mud = TextureRegistry.getTexture("minecraft:block/mud");
+    protected IconCoordinate topWet = TextureRegistry.getTexture("minecraft:block/farmland/wet_top");
+    protected IconCoordinate topWetFertilized = TextureRegistry.getTexture("minecraft:block/farmland/wet_fertilized_top");
+    protected IconCoordinate topDry = TextureRegistry.getTexture("minecraft:block/farmland/dry_top");
+    protected IconCoordinate topDryFertilized = TextureRegistry.getTexture("minecraft:block/farmland/dry_fertilized_top");
+    protected IconCoordinate mud = TextureRegistry.getTexture("minecraft:block/farmland/wet");
 
     public FarmlandBlockModel(Block block) {
         super(block);
@@ -40,4 +42,10 @@ public class FarmlandBlockModel<T extends Block> extends StandardBlockModel<T> {
             return atlasIndices[side.getId()];
         }
     }
+
+    @Override
+    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side) {
+        if (side >= 2 && blockAccess.getBlockId(x, y, z) == Blocks.FARMLAND_DIRT.id) return false;
+        return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+    }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
index f38dda9c1..6fd3e7ef6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FloweringCherryLeavesBlockModel.java
@@ -9,10 +9,10 @@ import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 public class FloweringCherryLeavesBlockModel<T extends Block> extends LeavesBlockModel<T> {
-    private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves_cherry_overlay");
-    private final IconCoordinate floweringCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves_cherry_flowering_overlay");
+    private final IconCoordinate grownCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_overlay");
+    private final IconCoordinate floweringCherryOverlay = TextureRegistry.getTexture("minecraft:block/leaves/cherry_flowering_overlay");
     public FloweringCherryLeavesBlockModel(Block block) {
-        super(block, "minecraft:block/leaves_cherry");
+        super(block, "minecraft:block/leaves/cherry");
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
index 365741006..2a1808869 100644
--- a/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/GrassBlockModel.java
@@ -18,11 +18,11 @@ public class GrassBlockModel<T extends Block> extends StandardBlockModel<T> {
     private static final IconCoordinate[] overlayIndices = new IconCoordinate[]{
             null,
             null,
-            TextureRegistry.getTexture("minecraft:block/grass_side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass_side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass_side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass_side_overlay")};
-    protected IconCoordinate snowSide = TextureRegistry.getTexture("minecraft:block/grass_snowy_side");
+            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+            TextureRegistry.getTexture("minecraft:block/grass/side_overlay")};
+    protected IconCoordinate snowSide = TextureRegistry.getTexture("minecraft:block/grass/snowy_side");
     public GrassBlockModel(Block block) {
         super(block);
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java
index aeb0d8e59..3eeae3dae 100644
--- a/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/LampBlockModel.java
@@ -14,8 +14,8 @@ public class LampBlockModel<T extends LampBlock> extends StandardBlockModel<T> {
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            texCoordsInactive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp_" + c.colorID + "_idle");
-            texCoordsActive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp_" + c.colorID + "_active");
+            texCoordsInactive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp/" + c.colorID + "_idle");
+            texCoordsActive[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/lamp/" + c.colorID + "_active");
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
index 34929a8f3..609a4404e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/MotionSensorBlockModel.java
@@ -8,7 +8,7 @@ import net.minecraft.core.block.MotionSensorBlock;
 import net.minecraft.core.util.helper.Side;
 
 public class MotionSensorBlockModel extends VeryRotatableBlockModel<MotionSensorBlock> {
-    protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/motionsensor_overlay");
+    protected IconCoordinate overlay = TextureRegistry.getTexture("minecraft:block/motion_sensor/active_front_overlay");
     public MotionSensorBlockModel(Block block) {
         super(block);
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java
index 7461e32df..015412d8d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PaintedChestBlockModel.java
@@ -21,19 +21,19 @@ public class PaintedChestBlockModel<T extends Block> extends ChestBlockModel<T>
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            String rootKey = "minecraft:block/chest_planks_oak_painted_" + c.colorID;
+            String rootKey = "minecraft:block/chest/planks_" + c.colorID + "/";
             texCoords[c.blockMeta] = new IconCoordinate[7];
-            texCoords[c.blockMeta][TEX_SINGLE_FRONT] = TextureRegistry.getTexture(rootKey + "_front");
-            texCoords[c.blockMeta][TEX_LEFT_FRONT] = TextureRegistry.getTexture(rootKey + "_left_front");
-            texCoords[c.blockMeta][TEX_RIGHT_FRONT] = TextureRegistry.getTexture(rootKey + "_right_front");
-            texCoords[c.blockMeta][TEX_LEFT_BACK] = TextureRegistry.getTexture(rootKey + "_left_back");
-            texCoords[c.blockMeta][TEX_RIGHT_BACK] = TextureRegistry.getTexture(rootKey + "_right_back");
-            texCoords[c.blockMeta][TEX_SIDE] = TextureRegistry.getTexture(rootKey + "_side");
-            texCoords[c.blockMeta][TEX_TOP] = TextureRegistry.getTexture(rootKey + "_top");
+            texCoords[c.blockMeta][TEX_SINGLE_FRONT] = TextureRegistry.getTexture(rootKey + "front");
+            texCoords[c.blockMeta][TEX_LEFT_FRONT] = TextureRegistry.getTexture(rootKey + "left_front");
+            texCoords[c.blockMeta][TEX_RIGHT_FRONT] = TextureRegistry.getTexture(rootKey + "right_front");
+            texCoords[c.blockMeta][TEX_LEFT_BACK] = TextureRegistry.getTexture(rootKey + "left_back");
+            texCoords[c.blockMeta][TEX_RIGHT_BACK] = TextureRegistry.getTexture(rootKey + "right_back");
+            texCoords[c.blockMeta][TEX_SIDE] = TextureRegistry.getTexture(rootKey + "side");
+            texCoords[c.blockMeta][TEX_TOP] = TextureRegistry.getTexture(rootKey + "top");
         }
     }
     public PaintedChestBlockModel(Block block) {
-        super(block, "minecraft:block/chest_planks_oak");
+        super(block, "minecraft:block/chest/planks/");
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
index 66ddeb97c..9ed8bf4c1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PaintedDoorBlockModel.java
@@ -11,11 +11,13 @@ import net.minecraft.core.util.helper.Side;
 public class PaintedDoorBlockModel<T extends DoorBlock> extends DoorBlockModel<T> {
     public static final IconCoordinate[] doorBottomTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
     public static final IconCoordinate[] doorTopTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    public static final IconCoordinate[] frameTopTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            doorTopTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + c.colorID + "_top");
-            doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door_planks_oak_" + c.colorID + "_bottom");
+            doorTopTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/top");
+            doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/bottom");
+            doorBottomTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/door/planks_" + c.colorID + "/frame_top");
         }
     }
     private final boolean isTop;
@@ -28,7 +30,7 @@ public class PaintedDoorBlockModel<T extends DoorBlock> extends DoorBlockModel<T
     {
         int color = (data >> 4) & DyeColor.MASK_COLOR;
         if (side.getAxis() == Axis.Y){
-            return TrapDoorPaintedBlockModel.topTextures[color];
+            return frameTopTextures[color];
         } else if (isTop){
             return doorTopTextures[color];
         }
diff --git a/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
index 9df336ece..c0aca2b45 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PebblesBlockModel.java
@@ -10,9 +10,9 @@ import net.minecraft.core.util.helper.Side;
 
 public class PebblesBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate[] pebbles = {
-            TextureRegistry.getTexture("minecraft:block/pebbles0"),
-            TextureRegistry.getTexture("minecraft:block/pebbles1"),
-            TextureRegistry.getTexture("minecraft:block/pebbles2")
+            TextureRegistry.getTexture("minecraft:block/pebbles/0"),
+            TextureRegistry.getTexture("minecraft:block/pebbles/1"),
+            TextureRegistry.getTexture("minecraft:block/pebbles/2")
     };
     public PebblesBlockModel(Block block) {
         super(block);
diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
index 3ca6f7468..df6c8f903 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
@@ -11,9 +11,9 @@ import org.jetbrains.annotations.Nullable;
 
 public class PistonBlockModel<T extends PistonBaseBlock> extends StandardBlockModel<T> {
     private final IconCoordinate faceTexture;
-    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston_side");
-    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston_top");
-    protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston_bottom");
+    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston/side");
+    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston/top");
+    protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston/bottom");
 
     protected final double headThickness;
     public PistonBlockModel(Block block, IconCoordinate faceTexture){
diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
index 0c49435fd..9444fab51 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
@@ -13,9 +13,9 @@ import org.jetbrains.annotations.Nullable;
 
 public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
     protected IconCoordinate pistonSide;
-    protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston_face");
-    protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_face_sticky");
-    protected IconCoordinate pistonSteel = TextureRegistry.getTexture("minecraft:block/piston_face_steel");
+    protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston/face");
+    protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_sticky/face");
+    protected IconCoordinate pistonSteel = TextureRegistry.getTexture("minecraft:block/piston_steel/face");
     @Nullable
     public IconCoordinate faceTextureOverride;
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java
index 26c0820fc..1a0bb8866 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PlanksPaintedBlockModel.java
@@ -11,7 +11,7 @@ public class PlanksPaintedBlockModel<T extends Block> extends StandardBlockModel
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks_oak_painted_" + c.colorID);
+            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/planks/" + c.colorID);
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
index 82cef26e1..1396706b0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PumpkinPieBlockModel.java
@@ -8,9 +8,9 @@ import net.minecraft.core.block.EdibleBlock;
 import net.minecraft.core.util.helper.Side;
 
 public class PumpkinPieBlockModel<T extends Block> extends StandardBlockModel<T> {
-    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_side");
-    protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_inside");
-    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie_top");
+    protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/side");
+    protected IconCoordinate insideTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/inner");
+    protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/pumpkin_pie/top");
 
     public PumpkinPieBlockModel(Block block) {
         super(block);
diff --git a/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
index 31dde58f5..117022fb1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RailBlockModel.java
@@ -12,10 +12,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
 public class RailBlockModel<T extends RailBlock> extends StandardBlockModel<T> {
-    protected IconCoordinate railCurve = TextureRegistry.getTexture("minecraft:block/rail_turn");
-    protected IconCoordinate powerActive = TextureRegistry.getTexture("minecraft:block/rail_powered_active");
-    protected IconCoordinate powerActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_powered_overlay");
-    protected IconCoordinate detectorActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_detector_overlay");
+    protected IconCoordinate railCurve = TextureRegistry.getTexture("minecraft:block/rail/turn");
+    protected IconCoordinate powerActive = TextureRegistry.getTexture("minecraft:block/rail_powered/active");
+    protected IconCoordinate powerActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_powered/active_overlay");
+    protected IconCoordinate detectorActiveOverlay = TextureRegistry.getTexture("minecraft:block/rail_detector/active_overlay");
 
     public RailBlockModel(Block block) {
         super(block);
diff --git a/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
index 69da98a57..5b5fc60b3 100644
--- a/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
@@ -15,8 +15,8 @@ public class TrapDoorPaintedBlockModel<T extends Block> extends TrapDoorBlockMod
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            topTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + c.colorID + "_top");
-            sideTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + c.colorID + "_side");
+            topTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor/planks_" + c.colorID + "/top");
+            sideTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor/planks_" + c.colorID + "/side");
         }
     }
     public TrapDoorPaintedBlockModel(Block block) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java
index 946b878f3..12f284f16 100644
--- a/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java
@@ -11,7 +11,7 @@ public class WoolBlockModel<T extends Block> extends StandardBlockModel<T> {
 
     static {
         for (DyeColor c : DyeColor.blockOrderedColors()){
-            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/wool_" + c.colorID);
+            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/wool/" + c.colorID);
         }
     }
     public WoolBlockModel(Block block) {
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
index a4caede0c..7b8433298 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
@@ -25,7 +25,7 @@ public class DynamicTextureTrommel extends DynamicTextureRotating {
 		
 		BufferedImage atlasImage = targetTexture.parentAtlas.atlas;
 		
-		IconCoordinate foreground = TextureRegistry.getTexture("minecraft:block/trommel_active_front_foreground");
+		IconCoordinate foreground = TextureRegistry.getTexture("minecraft:block/trommel/active_front_foreground");
 		dialImageData = new byte[foreground.getArea() * 4];
 		for(int x=0; x < foreground.width; x++) {
 			for(int y=0; y < foreground.height; y++) {
@@ -34,7 +34,7 @@ public class DynamicTextureTrommel extends DynamicTextureRotating {
 		}
 		dialTexRes = foreground.width;
 		
-		IconCoordinate background = TextureRegistry.getTexture("minecraft:block/trommel_active_front_background");
+		IconCoordinate background = TextureRegistry.getTexture("minecraft:block/trommel/active_front_background");
 		clockImageData = new byte[background.getArea() * 4];
 		for(int x=0; x < background.width; x++) {
 			for(int y=0; y < background.height; y++) {
